//One-dimensional grid Header

#ifndef ONEDGRID_H
#define ONEDGRID_H

#include "MasterInclude.h"
#include "AbstractMesh.h" //for definition of OFF
/****************************************************
  Class C1DFDGrid
  1-dimensional Grid/mesh abstraction
****************************************************/

class C1DFDGrid {

 protected:/*----------------------------------------------------------*/

	double   minX;
	double  *nodeX;     //nodal coordinates
	double  *gridX;     //cell/element center coordinates
	int      nCells;    //number of cells (for cell based methods)
	int      nX;        //number of divisions


 public:/*-----------------------------------------------------------*/

	//Constructors
	C1DFDGrid(){nCells=0;nX=0;minX=0.0;nodeX=NULL; gridX=NULL;}
	C1DFDGrid(double *X,int nX);

	~C1DFDGrid(){delete [] nodeX; delete [] gridX;}

	//Accessor Functions
        int    GetNumCells              () const  {return nCells;}

        double GetCellLength            (const int k) const;
	double GetNodeLocation          (const int k) const;
	bool   IsInCell                 (const double &x, const int k) const;
        bool   GetCellIndex             (const double &x, int &k) const;

	//inquiry functions
	bool   IsInside                 (const double &x) const;

	double InterpolateValue         (const double &x, Ironclad1DArray values) const;
        void   InterpolateValues        (const double &x, Ironclad2DArray values, Writeable1DArray intval, const int nval) const;
	//double C1DFDGrid::InterpolateDerivative    (const pt3D &pt, Ironclad1DArray values, const cmplex &dir) const;

	void   WriteGeometry            ();

};

#endif
